use anyhow::Context;

test_cases! {
    char::unreserved: {
        case_0: "0",
        case_1: "1",
        case_2: "2",
        case_3: "3",
        case_4: "4",
        case_5: "5",
        case_6: "6",
        case_7: "7",
        case_8: "8",
        case_9: "9",
        case_a: "a",
        case_a_upper: "A",
        case_apostrophe: "'",
        case_asterisk: "*",
        case_b: "b",
        case_b_upper: "B",
        case_c: "c",
        case_c_upper: "C",
        case_d: "d",
        case_d_upper: "D",
        case_dash: "-",
        case_e: "e",
        case_e_upper: "E",
        case_exclamation: "!",
        case_f: "f",
        case_f_upper: "F",
        case_g: "g",
        case_g_upper: "G",
        case_h: "h",
        case_h_upper: "H",
        case_i: "i",
        case_i_upper: "I",
        case_j: "j",
        case_j_upper: "J",
        case_k: "k",
        case_k_upper: "K",
        case_l: "l",
        case_l_upper: "L",
        case_m: "m",
        case_m_upper: "M",
        case_n: "n",
        case_n_upper: "N",
        case_o: "o",
        case_o_upper: "O",
        case_p: "p",
        case_p_upper: "P",
        case_parenthesis_left: "(",
        case_parenthesis_right: ")",
        case_period: ".",
        case_q: "q",
        case_q_upper: "Q",
        case_r: "r",
        case_r_upper: "R",
        case_s: "s",
        case_s_upper: "S",
        case_t: "t",
        case_t_upper: "T",
        case_tilde: "~",
        case_u: "u",
        case_u_upper: "U",
        case_underscore: "_",
        case_v: "v",
        case_v_upper: "V",
        case_w: "w",
        case_w_upper: "W",
        case_x: "x",
        case_x_upper: "X",
        case_y: "y",
        case_y_upper: "Y",
        case_z: "z",
        case_z_upper: "Z"
    }
}
